/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.58 Revision 1.112
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.58 2007/01/04 20:38:16 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.112 2009/07/06 18:58:41 robbat2 Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
7 4
8# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
9# Maintainer: Luca Longinotti <chtekk@gentoo.org> 7# - Luca Longinotti <chtekk@gentoo.org>
8# - Robin H. Johnson <robbat2@gentoo.org>
10 9
11# Note that MYSQL_VERSION_ID must be empty !!! 10WANT_AUTOCONF="latest"
11WANT_AUTOMAKE="latest"
12 12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15inherit eutils flag-o-matic gnuconfig autotools mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator
16 14
17# avoid running userspace code 8 times per ebuild :( 15# Shorten the path because the socket path length must be shorter than 107 chars
18if [[ "${_MYPVR}" != "${PVR}" ]] && [[ -n "${PVR}" ]] 16# and we will run a mysql server during test phase
19then 17S="${WORKDIR}/mysql"
20 _MYPVR=${PVR}
21 18
22 [[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070104" 19[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
23 20if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
24 if [[ ${PR#r} -lt 60 ]] ; then 21 EGIT_PROJECT=mysql-extras
25 IS_BITKEEPER=0 22 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
26 elif [[ ${PR#r} -lt 90 ]] ; then 23 inherit git
27 IS_BITKEEPER=60
28 else
29 IS_BITKEEPER=90
30 fi 24fi
31 25
32 # MYSQL_VERSION_ID will be: 26# MYSQL_VERSION_ID will be:
33 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 27# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
34 # This is an important part, because many of the choices the MySQL ebuild will do 28# This is an important part, because many of the choices the MySQL ebuild will do
35 # depend on this variable. 29# depend on this variable.
36 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 30# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
31# We also strip off upstream's trailing letter that they use to respin tarballs
32
37 MYSQL_VERSION_ID="" 33MYSQL_VERSION_ID=""
34tpv="${PV%[a-z]}"
38 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 35tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
39 for vatom in 0 1 2 3 ; do 36for vatom in 0 1 2 3 ; do
40 # pad to length 2 37 # pad to length 2
41 tpv[${vatom}]="00${tpv[${vatom}]}" 38 tpv[${vatom}]="00${tpv[${vatom}]}"
42 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 39 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
43 done 40done
44 # strip leading "0" (otherwise it's considered an octal number by BASH) 41# strip leading "0" (otherwise it's considered an octal number by BASH)
45 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 42MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
46 43
44# Community features are available in mysql-community
45# AND in the re-merged mysql-5.0.82 and newer
46if [ "${PN}" == "mysql-community" ]; then
47 MYSQL_COMMUNITY_FEATURES=1
48elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
49 MYSQL_COMMUNITY_FEATURES=1
50else
51 MYSQL_COMMUNITY_FEATURES=0
52fi
53
47 # Be warned, *DEPEND are version-dependant 54# Be warned, *DEPEND are version-dependant
55# These are used for both runtime and compiletime
48 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 56DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
49 userland_GNU? ( sys-process/procps ) 57 userland_GNU? ( sys-process/procps )
50 >=sys-apps/sed-4 58 >=sys-apps/sed-4
51 >=sys-apps/texinfo-4.7-r1 59 >=sys-apps/texinfo-4.7-r1
52 >=sys-libs/readline-4.1 60 >=sys-libs/readline-4.1
53 >=sys-libs/zlib-1.2.3 61 >=sys-libs/zlib-1.2.3"
54 "
55 62
56 # having different flavours at the same time is not a good idea 63# Having different flavours at the same time is not a good idea
57 for i in "" "-community" "-slotted" ; do 64for i in "" "-community" ; do
58 [[ "${i}" == ${PN#mysql} ]] || 65 [[ "${i}" == ${PN#mysql} ]] ||
59 DEPEND="${DEPEND} !dev-db/mysql${i}" 66 DEPEND="${DEPEND} !dev-db/mysql${i}"
60 done 67done
61 68
69RDEPEND="${DEPEND}
70 !minimal? ( dev-db/mysql-init-scripts )
71 selinux? ( sec-policy/selinux-mysql )"
72
73# compile-time-only
62 mysql_version_is_at_least "5.1" \ 74mysql_version_is_at_least "5.1" \
63 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 75|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
64 76
77# compile-time-only
78mysql_version_is_at_least "5.1.12" \
79&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
80
65 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL 81# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
66 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 82PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
67 83
68 if mysql_version_is_at_least "5.1.12" ; then 84# For other stuff to bring us in
69 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )" 85PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})"
86
87# Work out the default SERVER_URI correctly
88if [ -z "${SERVER_URI}" ]; then
89 # The community build is on the mirrors
90 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
91 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
92 # The (old) enterprise source is on the primary site only
93 elif [ "${PN}" == "mysql" ]; then
94 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
95 fi
70 fi 96fi
71 97
72 # Shorten the path because the socket path length must be shorter than 107 chars
73 # and we will run a mysql server during test phase
74 S="${WORKDIR}/mysql"
75
76 # BitKeeper dependency, compile-time only
77 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
78
79 if [[ ${PN} == "mysql-slotted" ]] ; then
80 DEPEND="${DEPEND} app-admin/eselect-mysql"
81 fi
82
83 if [[ ${PN} == "mysql-slotted" ]] ; then
84 SLOT=""
85 tpv=( ${PV//[-._]/ } )
86 for vatom in 0 1 2 ; do
87 SLOT="${SLOT}${tpv[${vatom}]}_"
88 done
89 #finally SLOT=5_0_24
90 SLOT=${SLOT:0:${#SLOT}-1}
91 else
92 SLOT="0"
93 fi
94
95 # Define correct SRC_URIs 98# Define correct SRC_URIs
96 SRC_URI=" 99SRC_URI="${SERVER_URI}"
97 ${SERVER_URI} 100
101[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
102 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
98 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 103 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
99 "
100 mysql_version_is_at_least "5.1.12" \ 104mysql_version_is_at_least "5.1.12" \
101 && [[ -n "${PBXT_VERSION}" ]] \ 105&& [[ -n "${PBXT_VERSION}" ]] \
102 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 106&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
103 107
104 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 108DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
105 HOMEPAGE="http://www.mysql.com/" 109HOMEPAGE="http://www.mysql.com/"
106 LICENSE="GPL-2" 110LICENSE="GPL-2"
111SLOT="0"
107 IUSE="big-tables debug embedded minimal perl selinux ssl static" 112IUSE="big-tables debug embedded minimal perl selinux ssl static"
108 RESTRICT="confcache"
109 113
110 mysql_version_is_at_least "4.1" \ 114mysql_version_is_at_least "4.1" \
111 && IUSE="${IUSE} latin1" 115&& IUSE="${IUSE} latin1"
112 116
113 mysql_version_is_at_least "4.1.3" \ 117mysql_version_is_at_least "4.1.3" \
114 && IUSE="${IUSE} cluster extraengine" 118&& IUSE="${IUSE} cluster extraengine"
115 119
116 mysql_version_is_at_least "5.0" \ 120mysql_version_is_at_least "5.0" \
117 || IUSE="${IUSE} raid" 121|| IUSE="${IUSE} raid"
118 122
119 mysql_version_is_at_least "5.0.18" \ 123mysql_version_is_at_least "5.0.18" \
120 && IUSE="${IUSE} max-idx-128" 124&& IUSE="${IUSE} max-idx-128"
121 125
122 mysql_version_is_at_least "5.1" \ 126mysql_version_is_at_least "5.1" \
123 && IUSE="${IUSE} innodb"
124
125 mysql_version_is_at_least "5.1" \
126 || IUSE="${IUSE} berkdb" 127|| IUSE="${IUSE} berkdb"
127 128
128 mysql_version_is_at_least "5.1.12" \ 129mysql_version_is_at_least "5.1.12" \
129 && IUSE="${IUSE} pbxt" 130&& IUSE="${IUSE} pbxt"
130 131
131 RDEPEND="${DEPEND} 132[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
132 sys-apps/mysql 133&& IUSE="${IUSE} community profiling"
133 selinux? ( sec-policy/selinux-mysql )
134 "
135 134
136fi # if [[ "${_MYPVR}" != "${PVR}" ]] 135case "${EAPI:-0}" in
137 136 2)
138EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 137 EXPORT_FUNCTIONS pkg_setup \
138 src_unpack src_prepare \
139 src_configure src_compile \
140 src_install \
141 pkg_preinst pkg_postinst \
139 pkg_postinst pkg_config pkg_postrm 142 pkg_config pkg_postrm
143 ;;
144 *)
145 EXPORT_FUNCTIONS pkg_setup \
146 src_unpack \
147 src_compile \
148 src_install \
149 pkg_preinst pkg_postinst \
150 pkg_config pkg_postrm
151 ;;
152esac
140 153
141# 154#
142# HELPER FUNCTIONS: 155# HELPER FUNCTIONS:
143# 156#
144
145bitkeeper_fetch() {
146
147 local reposuf
148 if [[ -z "${1}" ]] ; then
149 local tpv
150 tpv=( ${PV//[-._]/ } )
151 reposuf="mysql-${tpv[0]}.${tpv[1]}"
152 else
153 reposuf="${1}"
154 fi
155 einfo "using \"${reposuf}\" repository."
156 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
157 ## -- ebk_store_dir: bitkeeper sources store directory
158 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
159 ## -- ebk_fetch_cmd: bitkeeper fetch command
160 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
161 # hint: does not work
162 local ebk_fetch_cmd="sfioball"
163 ## -- ebk_update_cmd: bitkeeper update command
164 local ebk_update_cmd="update"
165
166 #addread "/etc/bitkeeper"
167 addwrite "${ebk_store_dir}"
168
169 if [[ ! -d "${ebk_store_dir}" ]]; then
170 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory"
171 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}."
172 fi
173
174 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}"
175
176 local wc_path=${reposuf}
177
178 if [[ ! -d "${wc_path}" ]]; then
179 local options="-r+"
180 # first check out
181 einfo "bitkeeper check out start -->"
182 einfo " repository: ${repo_uri}"
183 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \
184 || die "${EBK}: can't fetch from ${repo_uri}."
185 else
186 if [[ ! -d "${wc_path}/BK" ]]; then
187 popd
188 die "Look like ${wc_path} is not a bitkeeper path."
189 fi
190
191 # update working copy
192 einfo "bitkeeper update start -->"
193 einfo " repository: ${repo_uri}"
194
195 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
196 || die "BK: can't update from ${repo_uri} to ${wc_path}."
197 fi
198
199 einfo " working copy: ${wc_path}"
200 cd "${wc_path}"
201 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}."
202
203 echo
204 popd
205
206}
207 157
208mysql_disable_test() { 158mysql_disable_test() {
209 local testname="${1}" ; shift 159 local testname="${1}" ; shift
210 local reason="${@}" 160 local reason="${@}"
211 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 161 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
212 echo ${testname} : ${reason} >> "${mysql_disable_file}" 162 echo ${testname} : ${reason} >> "${mysql_disable_file}"
213 ewarn "test \"${testname}\" disabled because: \"${reason}\"" 163 ewarn "test '${testname}' disabled: '${reason}'"
214} 164}
215 165
216# void mysql_init_vars() 166# void mysql_init_vars()
217# 167#
218# Initialize global variables 168# Initialize global variables
219# 2005-11-19 <vivo@gentoo.org> 169# 2005-11-19 <vivo@gentoo.org>
220 170
221mysql_init_vars() { 171mysql_init_vars() {
222 if [[ ${SLOT} == "0" ]] ; then
223 MY_SUFFIX=""
224 else
225 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
226 fi
227 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 172 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
228 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 173 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
229 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 174 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
230 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 175 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
231 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 176 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
232 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 177 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
233 178
234 if [[ -z "${DATADIR}" ]] ; then 179 if [[ -z "${MY_DATADIR}" ]] ; then
235 DATADIR="" 180 MY_DATADIR=""
236 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 181 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
237 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \ 182 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
238 | sed -ne '/datadir/s|^--datadir=||p' \ 183 | sed -ne '/datadir/s|^--datadir=||p' \
239 | tail -n1` 184 | tail -n1`
240 if [[ -z "${DATADIR}" ]] ; then 185 if [[ -z "${MY_DATADIR}" ]] ; then
241 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 186 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
242 | sed -e 's/.*=\s*//'` 187 | sed -e 's/.*=\s*//' \
188 | tail -n1`
243 fi 189 fi
244 fi 190 fi
245 if [[ -z "${DATADIR}" ]] ; then 191 if [[ -z "${MY_DATADIR}" ]] ; then
246 DATADIR="${MY_LOCALSTATEDIR}" 192 MY_DATADIR="${MY_LOCALSTATEDIR}"
247 einfo "Using default DATADIR" 193 einfo "Using default MY_DATADIR"
248 fi 194 fi
249 elog "MySQL DATADIR is ${DATADIR}" 195 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
250 196
251 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 197 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
252 if [[ -e "${DATADIR}" ]] ; then 198 if [[ -e "${MY_DATADIR}" ]] ; then
253 elog "Previous datadir found, it's YOUR job to change" 199 # If you get this and you're wondering about it, see bug #207636
254 elog "ownership and take care of it" 200 elog "MySQL datadir found in ${MY_DATADIR}"
201 elog "A new one will not be created."
255 PREVIOUS_DATADIR="yes" 202 PREVIOUS_DATADIR="yes"
256 else 203 else
257 PREVIOUS_DATADIR="no" 204 PREVIOUS_DATADIR="no"
258 fi 205 fi
259 export PREVIOUS_DATADIR 206 export PREVIOUS_DATADIR
260 fi 207 fi
208 else
209 if [[ ${EBUILD_PHASE} == "config" ]]; then
210 local new_MY_DATADIR
211 new_MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
212 | sed -ne '/datadir/s|^--datadir=||p' \
213 | tail -n1`
214
215 if [[ ( -n "${new_MY_DATADIR}" ) && ( "${new_MY_DATADIR}" != "${MY_DATADIR}" ) ]]; then
216 ewarn "MySQL MY_DATADIR has changed"
217 ewarn "from ${MY_DATADIR}"
218 ewarn "to ${new_MY_DATADIR}"
219 MY_DATADIR="${new_MY_DATADIR}"
220 fi
221 fi
261 fi 222 fi
262 223
263 MY_SOURCEDIR=${SERVER_URI##*/} 224 MY_SOURCEDIR=${SERVER_URI##*/}
264 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 225 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
265 226
266 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 227 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
267 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 228 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
268 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR 229 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
269} 230}
270 231
271configure_minimal() { 232configure_minimal() {
272 # These are things we exclude from a minimal build, please 233 # These are things we exclude from a minimal build, please
273 # note that the server actually does get built and installed, 234 # note that the server actually does get built and installed,
274 # but we then delete it before packaging. 235 # but we then delete it before packaging.
275 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 236 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
276 237
277 for i in ${minimal_exclude_list} ; do 238 for i in ${minimal_exclude_list} ; do
278 myconf="${myconf} --without-${i}" 239 myconf="${myconf} --without-${i}"
279 done 240 done
280 myconf="${myconf} --with-extra-charsets=none" 241 myconf="${myconf} --with-extra-charsets=none"
281 myconf="${myconf} --enable-local-infile" 242 myconf="${myconf} --enable-local-infile"
282 243
283 if useq "static" ; then 244 if use static ; then
284 myconf="${myconf} --with-client-ldflags=-all-static" 245 myconf="${myconf} --with-client-ldflags=-all-static"
285 myconf="${myconf} --disable-shared" 246 myconf="${myconf} --disable-shared --with-pic"
286 else 247 else
287 myconf="${myconf} --enable-shared --enable-static" 248 myconf="${myconf} --enable-shared --enable-static"
288 fi 249 fi
289 250
290 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 251 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
291 myconf="${myconf} --with-charset=utf8" 252 myconf="${myconf} --with-charset=utf8"
292 myconf="${myconf} --with-collation=utf8_general_ci" 253 myconf="${myconf} --with-collation=utf8_general_ci"
293 else 254 else
294 myconf="${myconf} --with-charset=latin1" 255 myconf="${myconf} --with-charset=latin1"
295 myconf="${myconf} --with-collation=latin1_swedish_ci" 256 myconf="${myconf} --with-collation=latin1_swedish_ci"
303 myconf="${myconf} --with-mysqld-user=mysql" 264 myconf="${myconf} --with-mysqld-user=mysql"
304 myconf="${myconf} --with-server" 265 myconf="${myconf} --with-server"
305 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock" 266 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
306 myconf="${myconf} --without-libwrap" 267 myconf="${myconf} --without-libwrap"
307 268
308 if useq "static" ; then 269 if use static ; then
309 myconf="${myconf} --with-mysqld-ldflags=-all-static" 270 myconf="${myconf} --with-mysqld-ldflags=-all-static"
310 myconf="${myconf} --with-client-ldflags=-all-static" 271 myconf="${myconf} --with-client-ldflags=-all-static"
311 myconf="${myconf} --disable-shared" 272 myconf="${myconf} --disable-shared --with-pic"
312 else 273 else
313 myconf="${myconf} --enable-shared --enable-static" 274 myconf="${myconf} --enable-shared --enable-static"
314 fi 275 fi
315 276
316 if useq "debug" ; then 277 if use debug ; then
317 myconf="${myconf} --with-debug=full" 278 myconf="${myconf} --with-debug=full"
318 else 279 else
319 myconf="${myconf} --without-debug" 280 myconf="${myconf} --without-debug"
320 mysql_version_is_at_least "4.1.3" \ 281 mysql_version_is_at_least "4.1.3" \
321 && useq "cluster" \ 282 && use cluster \
322 && myconf="${myconf} --without-ndb-debug" 283 && myconf="${myconf} --without-ndb-debug"
323 fi 284 fi
324 285
286 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
287 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
288 ewarn "and a collation of ${MYSQL_DEFAULT_COLLATION}."
289 ewarn "You MUST file bugs without these variables set."
290 myconf="${myconf} --with-charset=${MYSQL_DEFAULT_CHARSET}"
291 myconf="${myconf} --with-collation=${MYSQL_DEFAULT_COLLATION}"
325 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then 292 elif mysql_version_is_at_least "4.1" && ! use latin1 ; then
326 myconf="${myconf} --with-charset=utf8" 293 myconf="${myconf} --with-charset=utf8"
327 myconf="${myconf} --with-collation=utf8_general_ci" 294 myconf="${myconf} --with-collation=utf8_general_ci"
328 else 295 else
329 myconf="${myconf} --with-charset=latin1" 296 myconf="${myconf} --with-charset=latin1"
330 myconf="${myconf} --with-collation=latin1_swedish_ci" 297 myconf="${myconf} --with-collation=latin1_swedish_ci"
331 fi 298 fi
332 299
333 if useq "embedded" ; then 300 if use embedded ; then
334 myconf="${myconf} --with-embedded-privilege-control" 301 myconf="${myconf} --with-embedded-privilege-control"
335 myconf="${myconf} --with-embedded-server" 302 myconf="${myconf} --with-embedded-server"
336 else 303 else
337 myconf="${myconf} --without-embedded-privilege-control" 304 myconf="${myconf} --without-embedded-privilege-control"
338 myconf="${myconf} --without-embedded-server" 305 myconf="${myconf} --without-embedded-server"
346 myconf="${myconf} --with-extra-tools" 313 myconf="${myconf} --with-extra-tools"
347 myconf="${myconf} --with-innodb" 314 myconf="${myconf} --with-innodb"
348 myconf="${myconf} --without-readline" 315 myconf="${myconf} --without-readline"
349 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 316 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
350 317
351 if useq "ssl" ; then
352 # --with-vio is not needed anymore, it's on by default and 318 # --with-vio is not needed anymore, it's on by default and
353 # has been removed from configure 319 # has been removed from configure
320 if use ssl ; then
354 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 321 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
322 fi
323
324 if mysql_version_is_at_least "5.1.11" ; then
325 myconf="${myconf} $(use_with ssl)"
326 else
327 myconf="${myconf} $(use_with ssl openssl)"
328 fi
329
355 if mysql_version_is_at_least "5.0.6" ; then 330 if mysql_version_is_at_least "5.0.60" ; then
356 # myconf="${myconf} --with-yassl" 331 if use berkdb ; then
332 elog "Berkeley DB support was disabled due to build failures"
333 elog "on multiple arches, go to a version earlier than 5.0.60"
334 elog "if you want it again. Gentoo bug #224067."
335 fi
357 myconf="${myconf} --with-ssl" 336 myconf="${myconf} --without-berkeley-db"
337 elif use berkdb ; then
338 # The following fix is due to a bug with bdb on SPARC's. See:
339 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
340 # It comes down to non-64-bit safety problems.
341 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
342 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
343 myconf="${myconf} --without-berkeley-db"
358 else 344 else
359 myconf="${myconf} --with-openssl" 345 myconf="${myconf} --with-berkeley-db=./bdb"
360 fi
361 else
362 myconf="${myconf} --without-openssl"
363 fi 346 fi
364 347 else
365 # The following fix is due to a bug with bdb on SPARC's. See:
366 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
367 # It comes down to non-64-bit safety problems.
368 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
369 elog "Berkeley DB support was disabled due to incompatible arch"
370 myconf="${myconf} --without-berkeley-db" 348 myconf="${myconf} --without-berkeley-db"
371 else
372 if useq "berkdb" ; then
373 myconf="${myconf} --with-berkeley-db=./bdb"
374 else
375 myconf="${myconf} --without-berkeley-db"
376 fi
377 fi 349 fi
378 350
379 if mysql_version_is_at_least "4.1.3" ; then 351 if mysql_version_is_at_least "4.1.3" ; then
380 myconf="${myconf} --with-geometry" 352 myconf="${myconf} --with-geometry"
381 myconf="${myconf} $(use_with cluster ndbcluster)" 353 myconf="${myconf} $(use_with cluster ndbcluster)"
382 fi 354 fi
383 355
384 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then 356 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
385 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 357 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
386 myconf="${myconf} --with-archive-storage-engine" 358 myconf="${myconf} --with-archive-storage-engine"
387 359
388 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 360 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
389 myconf="${myconf} --with-csv-storage-engine" 361 myconf="${myconf} --with-csv-storage-engine"
399 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 371 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
400 myconf="${myconf} --with-federated-storage-engine" 372 myconf="${myconf} --with-federated-storage-engine"
401 fi 373 fi
402 fi 374 fi
403 375
376 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
377 myconf="${myconf} `use_enable community community-features`"
378 if use community; then
379 myconf="${myconf} `use_enable profiling`"
380 else
381 myconf="${myconf} --disable-profiling"
382 fi
383 fi
384
404 mysql_version_is_at_least "5.0.18" \ 385 mysql_version_is_at_least "5.0.18" \
405 && useq "max-idx-128" \ 386 && use max-idx-128 \
406 && myconf="${myconf} --with-max-indexes=128" 387 && myconf="${myconf} --with-max-indexes=128"
407} 388}
408 389
409configure_51() { 390configure_51() {
410 # TODO: !!!! readd --without-readline 391 # TODO: !!!! readd --without-readline
415 myconf="${myconf} --with-geometry" 396 myconf="${myconf} --with-geometry"
416 myconf="${myconf} --with-readline" 397 myconf="${myconf} --with-readline"
417 myconf="${myconf} --with-row-based-replication" 398 myconf="${myconf} --with-row-based-replication"
418 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 399 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
419 myconf="${myconf} --without-pstack" 400 myconf="${myconf} --without-pstack"
420 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 401 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
421 402
422 # 5.1 introduces a new way to manage storage engines (plugins) 403 # 5.1 introduces a new way to manage storage engines (plugins)
423 # like configuration=none 404 # like configuration=none
424 local plugins="csv,myisam,myisammrg,heap" 405 local plugins="csv,myisam,myisammrg,heap"
425 if useq "extraengine" ; then 406 if use extraengine ; then
426 # like configuration=max-no-ndb, archive and example removed in 5.1.11 407 # like configuration=max-no-ndb, archive and example removed in 5.1.11
427 plugins="${plugins},archive,blackhole,example,federated,partition" 408 plugins="${plugins},archive,blackhole,example,federated,partition"
428 409
429 elog "Before using the Federated storage engine, please be sure to read" 410 elog "Before using the Federated storage engine, please be sure to read"
430 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 411 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
431 fi 412 fi
432 413
433 if useq "innodb" ; then 414 # Upstream specifically requests that InnoDB always be built.
434 plugins="${plugins},innobase" 415 plugins="${plugins},innobase"
435 fi
436 416
437 # like configuration=max-no-ndb 417 # like configuration=max-no-ndb
438 if useq "cluster" ; then 418 if use cluster ; then
439 plugins="${plugins},ndbcluster" 419 plugins="${plugins},ndbcluster"
440 myconf="${myconf} --with-ndb-binlog" 420 myconf="${myconf} --with-ndb-binlog"
441 fi 421 fi
442 422
443 if mysql_version_is_at_least "5.2" ; then 423 if mysql_version_is_at_least "5.2" ; then
445 fi 425 fi
446 426
447 myconf="${myconf} --with-plugins=${plugins}" 427 myconf="${myconf} --with-plugins=${plugins}"
448} 428}
449 429
450pbxt_src_compile() { 430pbxt_src_configure() {
451 mysql_init_vars 431 mysql_init_vars
452 432
453 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 433 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
454 434
455 einfo "Reconfiguring dir '${PWD}'" 435 einfo "Reconfiguring dir '${PWD}'"
456 AT_GNUCONF_UPDATE="yes" eautoreconf 436 AT_GNUCONF_UPDATE="yes" eautoreconf
457 437
458 local myconf 438 local myconf=""
459 myconf="${myconf} --with-mysql=${S}"
460 mkdir -p ${T}/lib
461 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}" 439 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
462 useq "debug" && myconf="${myconf} --with-debug=full" 440 use debug && myconf="${myconf} --with-debug=full"
463 # TODO is safe/needed to use econf here ? 441 # TODO: is it safe/needed to use econf here ?
464 ./configure ${myconf} || die "problem configuring pbxt storage engine" 442 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
443}
444
445pbxt_src_compile() {
446 # Be backwards compatible for now
447 if [[ $EAPI != 2 ]]; then
448 pbxt_src_configure
449 fi
465 # TODO is safe/needed to use emake here ? 450 # TODO: is it safe/needed to use emake here ?
466 make || die "problem making pbxt storage engine (${myconf})" 451 make || die "Problem making PBXT storage engine (${myconf})"
467 452
468 popd 453 popd
469 # TODO: modify test suite 454 # TODO: modify test suite for PBXT
470} 455}
471 456
472pbxt_src_install() { 457pbxt_src_install() {
473 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 458 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
474 make install || die "failed pbxt install" 459 make install || die "Failed to install PBXT"
475 popd 460 popd
476} 461}
477 462
478# 463#
479# EBUILD FUNCTIONS 464# EBUILD FUNCTIONS
480# 465#
481
482mysql_pkg_setup() { 466mysql_pkg_setup() {
483 enewgroup mysql 60 || die "problem adding 'mysql' group" 467 if hasq test ${FEATURES} ; then
484 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 468 if ! use minimal ; then
469 if [[ $UID -eq 0 ]]; then
470 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
471 fi
472 fi
473 fi
485 474
486 # Check for USE flag problems in pkg_setup 475 # Check for USE flag problems in pkg_setup
487 if useq "static" && useq "ssl" ; then 476 if use static && use ssl ; then
488 eerror "MySQL does not support being built statically with SSL support enabled!" 477 eerror "MySQL does not support being built statically with SSL support enabled!"
489 die "MySQL does not support being built statically with SSL support enabled!" 478 die "MySQL does not support being built statically with SSL support enabled!"
490 fi 479 fi
491 480
492 if ! mysql_version_is_at_least "5.0" \ 481 if ! mysql_version_is_at_least "5.0" \
493 && useq "raid" \ 482 && use raid \
494 && useq "static" ; then 483 && use static ; then
495 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 484 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
496 eerror "with RAID support enabled." 485 eerror "with RAID support enabled."
497 die "USE flags 'raid' and 'static' conflict!" 486 die "USE flags 'raid' and 'static' conflict!"
498 fi 487 fi
499 488
500 if mysql_version_is_at_least "4.1.3" \ 489 if mysql_version_is_at_least "4.1.3" \
501 && ( useq "cluster" || useq "extraengine" ) \ 490 && ( use cluster || use extraengine ) \
502 && useq "minimal" ; then 491 && use minimal ; then
503 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 492 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
504 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 493 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
505 fi 494 fi
506 495
496 # This should come after all of the die statements
497 enewgroup mysql 60 || die "problem adding 'mysql' group"
498 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
499
507 mysql_check_version_range "4.0 to 5.0.99.99" \ 500 mysql_check_version_range "4.0 to 5.0.99.99" \
508 && useq "berkdb" \ 501 && use berkdb \
509 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 502 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
510} 503}
511 504
512mysql_src_unpack() { 505mysql_src_unpack() {
513 # Initialize the proper variables first 506 # Initialize the proper variables first
514 mysql_init_vars 507 mysql_init_vars
515 508
516 unpack ${A} 509 unpack ${A}
517 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 510 # Grab the patches
518 if mysql_check_version_range "5.1 to 5.1.99" ; then 511 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
519 bitkeeper_fetch "mysql-5.1-ndb" 512
520 elif mysql_check_version_range "5.2.0 to 5.2.99" ; then
521 bitkeeper_fetch "mysql-5.2-falcon"
522 else
523 bitkeeper_fetch
524 fi
525 cd "${S}"
526 einfo "running upstream autorun on bk sources"
527 BUILD/autorun.sh
528 else
529 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 513 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
514
515 # Be backwards compatible for now
516 if [[ $EAPI != 2 ]]; then
517 mysql_src_prepare
518 fi
519}
520
521mysql_src_prepare() {
530 cd "${S}" 522 cd "${S}"
531 fi
532 523
533 # Apply the patches for this MySQL version 524 # Apply the patches for this MySQL version
534 EPATCH_SUFFIX="patch" 525 EPATCH_SUFFIX="patch"
535 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 526 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
527 # Clean out old items
528 rm -f "${EPATCH_SOURCE}"/*
529 # Now link in right patches
536 mysql_mv_patches 530 mysql_mv_patches
537 epatch || die "failed to apply all patches" 531 # And apply
532 epatch
538 533
539 # Additional checks, remove bundled zlib 534 # Additional checks, remove bundled zlib
540 rm -f "${S}/zlib/"*.[ch] 535 rm -f "${S}/zlib/"*.[ch]
541 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 536 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
542 rm -f "scripts/mysqlbug" 537 rm -f "scripts/mysqlbug"
557 552
558 local rebuilddirlist d 553 local rebuilddirlist d
559 554
560 if mysql_version_is_at_least "5.1.12" ; then 555 if mysql_version_is_at_least "5.1.12" ; then
561 rebuilddirlist="." 556 rebuilddirlist="."
562 # TODO IMPO! Check this with a cmake expert 557 # TODO: check this with a cmake expert
563 useq "innodb" \
564 && cmake \ 558 cmake \
565 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \ 559 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
566 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \ 560 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
567 "storage/innobase" 561 "storage/innobase"
568 else 562 else
569 rebuilddirlist=". innobase" 563 rebuilddirlist=". innobase"
570 fi 564 fi
571 565
575 AT_GNUCONF_UPDATE="yes" eautoreconf 569 AT_GNUCONF_UPDATE="yes" eautoreconf
576 popd &>/dev/null 570 popd &>/dev/null
577 done 571 done
578 572
579 if mysql_check_version_range "4.1 to 5.0.99.99" \ 573 if mysql_check_version_range "4.1 to 5.0.99.99" \
580 && useq "berkdb" ; then 574 && use berkdb ; then
581 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 575 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
576 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
577 || die "Could not copy libtool.m4 to bdb/dist/"
578 #These files exist only with libtool-2*, and need to be included.
579 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
580 cat "/usr/share/aclocal/ltsugar.m4" >> "bdb/dist/aclocal/libtool.ac"
581 cat "/usr/share/aclocal/ltversion.m4" >> "bdb/dist/aclocal/libtool.ac"
582 cat "/usr/share/aclocal/lt~obsolete.m4" >> "bdb/dist/aclocal/libtool.ac"
583 cat "/usr/share/aclocal/ltoptions.m4" >> "bdb/dist/aclocal/libtool.ac"
584 fi
582 pushd "bdb/dist" \ 585 pushd "bdb/dist" &>/dev/null
583 && sh s_all \ 586 sh s_all \
584 || die "Failed bdb reconfigure" \ 587 || die "Failed bdb reconfigure"
585 &>/dev/null
586 popd &>/dev/null 588 popd &>/dev/null
587 fi 589 fi
588} 590}
589 591
590mysql_src_compile() { 592mysql_src_configure() {
591 # Make sure the vars are correctly initialized 593 # Make sure the vars are correctly initialized
592 mysql_init_vars 594 mysql_init_vars
593 595
594 # $myconf is modified by the configure_* functions 596 # $myconf is modified by the configure_* functions
595 local myconf="" 597 local myconf=""
596 598
597 if useq "minimal" ; then 599 if use minimal ; then
598 configure_minimal 600 configure_minimal
599 else 601 else
600 configure_common 602 configure_common
601 if mysql_version_is_at_least "5.1.10" ; then 603 if mysql_version_is_at_least "5.1.10" ; then
602 configure_51 604 configure_51
609 filter-flags "-O" "-O[01]" 611 filter-flags "-O" "-O[01]"
610 612
611 # glib-2.3.2_pre fix, bug #16496 613 # glib-2.3.2_pre fix, bug #16496
612 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 614 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
613 615
616 # As discovered by bug #246652, doing a double-level of SSP causes NDB to
617 # fail badly during cluster startup.
618 if [[ $(gcc-major-version) -lt 4 ]]; then
619 filter-flags "-fstack-protector-all"
620 fi
621
614 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing" 622 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
615 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 623 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
616 mysql_version_is_at_least "5.0" \ 624 mysql_version_is_at_least "5.0" \
617 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 625 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
618 export CXXFLAGS 626 export CXXFLAGS
619 627
620 econf \ 628 econf \
621 --program-suffix="${MY_SUFFIX}" \
622 --libexecdir="/usr/sbin" \ 629 --libexecdir="/usr/sbin" \
623 --sysconfdir="${MY_SYSCONFDIR}" \ 630 --sysconfdir="${MY_SYSCONFDIR}" \
624 --localstatedir="${MY_LOCALSTATEDIR}" \ 631 --localstatedir="${MY_LOCALSTATEDIR}" \
625 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 632 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
626 --libdir="${MY_LIBDIR}" \ 633 --libdir="${MY_LIBDIR}" \
635 # TODO: Move this before autoreconf !!! 642 # TODO: Move this before autoreconf !!!
636 find . -type f -name Makefile -print0 \ 643 find . -type f -name Makefile -print0 \
637 | xargs -0 -n100 sed -i \ 644 | xargs -0 -n100 sed -i \
638 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 645 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
639 646
647 if [[ $EAPI == 2 ]]; then
648 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure
649 fi
650}
651
652mysql_src_compile() {
653 # Be backwards compatible for now
654 if [[ $EAPI != 2 ]]; then
655 mysql_src_configure
656 fi
657
640 emake || die "emake failed" 658 emake || die "emake failed"
641 659
642 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile 660 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
643} 661}
644 662
645mysql_src_install() { 663mysql_src_install() {
646 # Make sure the vars are correctly initialized 664 # Make sure the vars are correctly initialized
647 mysql_init_vars 665 mysql_init_vars
648 666
649 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 667 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
650 668
651 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install 669 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
652
653 insinto "${MY_INCLUDEDIR}"
654 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
655 670
656 # Convenience links 671 # Convenience links
672 einfo "Making Convenience links for mysqlcheck multi-call binary"
657 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 673 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
658 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 674 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
659 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 675 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
660 676
661 # Various junk (my-*.cnf moved elsewhere) 677 # Various junk (my-*.cnf moved elsewhere)
678 einfo "Removing duplicate /usr/share/mysql files"
662 rm -Rf "${D}/usr/share/info" 679 rm -Rf "${D}/usr/share/info"
663 for removeme in "mysql-log-rotate" mysql.server* \ 680 for removeme in "mysql-log-rotate" mysql.server* \
664 binary-configure* my-*.cnf mi_test_all* 681 binary-configure* my-*.cnf mi_test_all*
665 do 682 do
666 rm -f "${D}"/usr/share/mysql/${removeme} 683 rm -f "${D}"/usr/share/mysql/${removeme}
667 done 684 done
668 685
669 # TODO change at Makefile-am level
670 if [[ ${PN} == "mysql-slotted" ]] ; then
671 for moveme in "mysql_fix_privilege_tables.sql" \
672 "fill_help_tables.sql" "ndb-config-2-node.ini"
673 do
674 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
675 done
676 fi
677
678 # clean up stuff for a minimal build 686 # Clean up stuff for a minimal build
679 if useq "minimal" ; then 687 if use minimal ; then
688 einfo "Remove all extra content for minimal build"
680 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 689 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
681 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 690 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
682 rm -f "${D}/usr/sbin/mysqld" 691 rm -f "${D}/usr/sbin/mysqld"
683 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 692 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
684 fi 693 fi
685 694
686 if [[ ${PN} == "mysql-slotted" ]] ; then
687 local notcatched=$(ls "${D}/usr/share/mysql"/*)
688 if [[ -n "${notcatched}" ]] ; then
689 ewarn "QA notice"
690 ewarn "${notcatched} files in /usr/share/mysql"
691 ewarn "bug mysql-herd to manage them"
692 fi
693 rm -Rf "${D}/usr/share/mysql"
694 fi
695
696 # Configuration stuff 695 # Configuration stuff
697 if mysql_version_is_at_least "4.1" ; then 696 if mysql_version_is_at_least "4.1" ; then
698 mysql_mycnf_version="4.1" 697 mysql_mycnf_version="4.1"
699 else 698 else
700 mysql_mycnf_version="4.0" 699 mysql_mycnf_version="4.0"
701 fi 700 fi
701 einfo "Building default my.cnf"
702 insinto "${MY_SYSCONFDIR}" 702 insinto "${MY_SYSCONFDIR}"
703 doins scripts/mysqlaccess.conf 703 doins scripts/mysqlaccess.conf
704 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
705 -e "s!@DATADIR@!${DATADIR}!g" \ 704 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
706 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 705 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
707 > "${TMPDIR}/my.cnf.ok" 706 > "${TMPDIR}/my.cnf.ok"
708 if mysql_version_is_at_least "4.1" && useq "latin1" ; then 707 if mysql_version_is_at_least "4.1" && use latin1 ; then
709 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 708 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
710 fi 709 fi
711 newins "${TMPDIR}/my.cnf.ok" my.cnf 710 newins "${TMPDIR}/my.cnf.ok" my.cnf
712 711
713 # Minimal builds don't have the MySQL server 712 # Minimal builds don't have the MySQL server
714 if ! useq "minimal" ; then 713 if ! use minimal ; then
714 einfo "Creating initial directories"
715 # Empty directories ... 715 # Empty directories ...
716 diropts "-m0750" 716 diropts "-m0750"
717 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 717 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
718 dodir "${DATADIR}" 718 dodir "${MY_DATADIR}"
719 keepdir "${DATADIR}" 719 keepdir "${MY_DATADIR}"
720 chown -R mysql:mysql "${D}/${DATADIR}" 720 chown -R mysql:mysql "${D}/${MY_DATADIR}"
721 fi 721 fi
722 722
723 diropts "-m0755" 723 diropts "-m0755"
724 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 724 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
725 dodir "${folder}" 725 dodir "${folder}"
727 chown -R mysql:mysql "${D}/${folder}" 727 chown -R mysql:mysql "${D}/${folder}"
728 done 728 done
729 fi 729 fi
730 730
731 # Docs 731 # Docs
732 einfo "Installing docs"
732 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 733 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
734 doinfo "${S}"/Docs/mysql.info
733 735
734 # Minimal builds don't have the MySQL server 736 # Minimal builds don't have the MySQL server
735 if ! useq "minimal" ; then 737 if ! use minimal ; then
738 einfo "Including support files and sample configurations"
739 docinto "support-files"
740 for script in \
741 "${S}"/support-files/my-*.cnf \
742 "${S}"/support-files/magic \
743 "${S}"/support-files/ndb-config-2-node.ini
744 do
745 dodoc "${script}"
746 done
747
748 docinto "scripts"
749 for script in "${S}"/scripts/mysql* ; do
750 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
751 done
752
753 fi
754
755 mysql_lib_symlinks "${D}"
756}
757
758mysql_pkg_preinst() {
759 enewgroup mysql 60 || die "problem adding 'mysql' group"
760 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
761}
762
763mysql_pkg_postinst() {
764 # Make sure the vars are correctly initialized
765 mysql_init_vars
766
767 # Check FEATURES="collision-protect" before removing this
768 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
769
770 # Secure the logfiles
771 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
772 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
773 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
774
775 # Minimal builds don't have the MySQL server
776 if ! use minimal ; then
736 docinto "support-files" 777 docinto "support-files"
737 for script in \ 778 for script in \
738 support-files/my-*.cnf \ 779 support-files/my-*.cnf \
739 support-files/magic \ 780 support-files/magic \
740 support-files/ndb-config-2-node.ini 781 support-files/ndb-config-2-node.ini
744 785
745 docinto "scripts" 786 docinto "scripts"
746 for script in scripts/mysql* ; do 787 for script in scripts/mysql* ; do
747 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 788 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
748 done 789 done
749 fi
750 790
751 if [[ ${PN} == "mysql-slotted" ]] ; then 791 einfo
752 # MOVED HERE DUE TO BUG #121445 792 elog "You might want to run:"
753 # create a list of files, to be used 793 elog "\"emerge --config =${CATEGORY}/${PF}\""
754 # by external utilities 794 elog "if this is a new install."
755 mkdir -p "${D}/var/lib/eselect/mysql/" 795 einfo
756 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
757 pushd "${D}/" &>/dev/null
758 find usr/bin/ usr/sbin/ \
759 -type f -name "*${MY_SUFFIX}*" \
760 -and -not -name "mysql_config${MY_SUFFIX}" \
761 > "${filelist}"
762 find usr/share/man \
763 -type f -name "*${MY_SUFFIX}*" \
764 | sed -e 's/$/.gz/' \
765 >> "${filelist}"
766 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
767 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
768 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
769 popd &>/dev/null
770 fi 796 fi
771 797
772 mysql_lib_symlinks "${D}" 798 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
773} 799 # TODO: explain it better
800 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
801 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
802 elog "if, after that, you cannot start the MySQL server,"
803 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
804 elog "use the MySQL upgrade script to restore the table"
805 elog "or execute the following SQL command:"
806 elog " CREATE TABLE IF NOT EXISTS plugin ("
807 elog " name char(64) binary DEFAULT '' NOT NULL,"
808 elog " dl char(128) DEFAULT '' NOT NULL,"
809 elog " PRIMARY KEY (name)"
810 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
811 fi
774 812
775mysql_pkg_preinst() { 813 mysql_check_version_range "4.0 to 5.0.99.99" \
776 enewgroup mysql 60 || die "problem adding 'mysql' group" 814 && use berkdb \
777 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 815 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
778} 816}
779 817
780mysql_pkg_postinst() { 818mysql_pkg_config() {
819 local old_MY_DATADIR="${MY_DATADIR}"
820
781 # Make sure the vars are correctly initialized 821 # Make sure the vars are correctly initialized
782 mysql_init_vars 822 mysql_init_vars
783 823
784 # Check FEATURES="collision-protect" before removing this
785 [[ -d "${ROOT}/var/log/mysql" ]] \
786 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
787
788 # Secure the logfiles
789 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
790 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
791 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
792
793 # Minimal builds don't have the MySQL server
794 if ! useq "minimal" ; then
795 docinto "support-files"
796 for script in \
797 support-files/my-*.cnf \
798 support-files/magic \
799 support-files/ndb-config-2-node.ini
800 do
801 dodoc "${script}"
802 done
803
804 docinto "scripts"
805 for script in scripts/mysql* ; do
806 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
807 done
808 fi
809
810 einfo "you may want to read slotting upgrade documents in the overlay"
811 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then
812 # TODO tell it better ;-)
813 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
814 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
815 einfo "if, after that you cannot start the mysql server"
816 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
817 einfo "use the mysql upgrade script to restore the table"
818 einfo " or "
819 einfo "CREATE TABLE IF NOT EXISTS plugin ("
820 einfo " name char(64) binary DEFAULT '' NOT NULL,"
821 einfo " dl char(128) DEFAULT '' NOT NULL,"
822 einfo " PRIMARY KEY (name)"
823 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;"
824 fi
825 mysql_check_version_range "4.0 to 5.0.99.99" \
826 && useq "berkdb" \
827 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
828}
829
830mysql_pkg_config() {
831 # Make sure the vars are correctly initialized
832 mysql_init_vars
833
834 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 824 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
835 825
836 if built_with_use ${CATEGORY}/${PN} minimal ; then 826 if built_with_use ${CATEGORY}/${PN} minimal ; then
837 die "Minimal builds do NOT include the MySQL server" 827 die "Minimal builds do NOT include the MySQL server"
828 fi
829
830 if [[ ( -n "${MY_DATADIR}" ) && ( "${MY_DATADIR}" != "${old_MY_DATADIR}" ) ]]; then
831 local MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${MY_DATADIR})"
832 local old_MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${old_MY_DATADIR})"
833
834 if [[ -d "${old_MY_DATADIR_s}" ]]; then
835 if [[ -d "${MY_DATADIR_s}" ]]; then
836 ewarn "Both ${old_MY_DATADIR_s} and ${MY_DATADIR_s} exist"
837 ewarn "Attempting to use ${MY_DATADIR_s} and preserving ${old_MY_DATADIR_s}"
838 else
839 elog "Moving MY_DATADIR from ${old_MY_DATADIR_s} to ${MY_DATADIR_s}"
840 mv --strip-trailing-slashes -T "${old_MY_DATADIR_s}" "${MY_DATADIR_s}" \
841 || die "Moving MY_DATADIR failed"
842 fi
843 else
844 ewarn "Previous MY_DATADIR (${old_MY_DATADIR_s}) does not exist"
845 if [[ -d "${MY_DATADIR_s}" ]]; then
846 ewarn "Attempting to use ${MY_DATADIR_s}"
847 else
848 eerror "New MY_DATADIR (${MY_DATADIR_s}) does not exist"
849 die "Configuration Failed! Please reinstall ${CATEGORY}/${PN}"
850 fi
851 fi
838 fi 852 fi
839 853
840 local pwd1="a" 854 local pwd1="a"
841 local pwd2="b" 855 local pwd2="b"
842 local maxtry=5 856 local maxtry=5
843 857
844 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 858 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
845 ewarn "You have already a MySQL database in place." 859 ewarn "You have already a MySQL database in place."
846 ewarn "(${ROOT}/${DATADIR}/*)" 860 ewarn "(${ROOT}/${MY_DATADIR}/*)"
847 ewarn "Please rename or delete it if you wish to replace it." 861 ewarn "Please rename or delete it if you wish to replace it."
848 die "MySQL database already exists!" 862 die "MySQL database already exists!"
849 fi 863 fi
864
865 # Bug #213475 - MySQL _will_ object strenously if your machine is named
866 # localhost. Also causes weird failures.
867 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
850 868
851 einfo "Creating the mysql database and setting proper" 869 einfo "Creating the mysql database and setting proper"
852 einfo "permissions on it ..." 870 einfo "permissions on it ..."
853 871
854 einfo "Insert a password for the mysql 'root' user" 872 einfo "Insert a password for the mysql 'root' user"
870 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 888 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
871 || touch "${TMPDIR}/fill_help_tables.sql" 889 || touch "${TMPDIR}/fill_help_tables.sql"
872 help_tables="${TMPDIR}/fill_help_tables.sql" 890 help_tables="${TMPDIR}/fill_help_tables.sql"
873 891
874 pushd "${TMPDIR}" &>/dev/null 892 pushd "${TMPDIR}" &>/dev/null
875 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 893 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
894 if [ $? -ne 0 ]; then
895 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
896 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
897 fi
876 popd &>/dev/null 898 popd &>/dev/null
877 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 899 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
878 || die "MySQL databases not installed" 900 || die "MySQL databases not installed"
879 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 901 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
880 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 902 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
881 903
882 if mysql_version_is_at_least "4.1.3" ; then 904 if mysql_version_is_at_least "4.1.3" ; then
883 options="--skip-ndbcluster" 905 options="--skip-ndbcluster"
884 906
885 # Filling timezones, see 907 # Filling timezones, see
896 local mysqld="${ROOT}/usr/sbin/mysqld \ 918 local mysqld="${ROOT}/usr/sbin/mysqld \
897 ${options} \ 919 ${options} \
898 --user=mysql \ 920 --user=mysql \
899 --skip-grant-tables \ 921 --skip-grant-tables \
900 --basedir=${ROOT}/usr \ 922 --basedir=${ROOT}/usr \
901 --datadir=${ROOT}/${DATADIR} \ 923 --datadir=${ROOT}/${MY_DATADIR} \
902 --skip-innodb \ 924 --skip-innodb \
903 --skip-bdb \ 925 --skip-bdb \
904 --skip-networking \ 926 --skip-networking \
905 --max_allowed_packet=8M \ 927 --max_allowed_packet=8M \
906 --net_buffer_length=16K \ 928 --net_buffer_length=16K \
936 wait %1 958 wait %1
937 einfo "Done" 959 einfo "Done"
938} 960}
939 961
940mysql_pkg_postrm() { 962mysql_pkg_postrm() {
941 if [[ ${PN} == "mysql-slotted" ]] ; then
942 mysql_lib_symlinks 963 : # mysql_lib_symlinks "${D}"
943 mysql_clients_link_to_best_version
944 fi
945} 964}

Legend:
Removed from v.1.58  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.20